package com.muyu.common.datascope;

import com.baomidou.mybatisplus.core.handlers.MetaObjectHandler;
import com.muyu.common.security.utils.SecurityUtils;
import lombok.extern.log4j.Log4j2;
import org.apache.ibatis.reflection.MetaObject;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * @Author：zhangchengzhi
 * @Package：com.muyu.common.datascope
 * @Project：cloud-common-datascope
 * @name：MyMetaObjectHandler
 * @Date：2024/8/8 16:16
 */

@Log4j2
public class MyMetaObjectHandler implements MetaObjectHandler {

  public MyMetaObjectHandler(){
      log.info("元对象字段填充控制器 ------ 加载完成");
  }

    @Override                     //插入元对象字段填充(用于插入时对公共字段的填充)
    public void insertFill(MetaObject metaObject) {
        this.setFieldValByName("createBy", SecurityUtils.getUserId(),metaObject);
        this.setFieldValByName("createTime", new Date(),metaObject);
        log.info("添加对象元数据字段填充-[createBy:[{}],createTime:[{}]",
                SecurityUtils.getUserId(),new Date());
    }
    @Override                  //更新元对象字段填充(用于更新是对公共字段的填充)
    public void updateFill(MetaObject metaObject) {
        this.setFieldValByName("updateBy", SecurityUtils.getUserId(),metaObject);
        this.setFieldValByName("updateTime", new Date(),metaObject);
        log.info("修改对象元数据字段填充-[updateBy:[{}],updateTime:[{}]",
                SecurityUtils.getUserId(),new Date());
    }
}
